diff --git a/Tmain/broken-tagname-in-ectags-format.d/exit-expected.txt b/Tmain/broken-tagname-in-ectags-format.d/exit-expected.txt
new file mode 100644
index 0000000000..573541ac97
--- /dev/null
+++ b/Tmain/broken-tagname-in-ectags-format.d/exit-expected.txt
@@ -0,0 +1 @@
+0
diff --git a/Tmain/broken-tagname-in-ectags-format.d/input.cst b/Tmain/broken-tagname-in-ectags-format.d/input.cst
new file mode 100644
index 0000000000..711d47ed56
--- /dev/null
+++ b/Tmain/broken-tagname-in-ectags-format.d/input.cst
@@ -0,0 +1,2 @@
+b
+
diff --git a/Tmain/broken-tagname-in-ectags-format.d/run.sh b/Tmain/broken-tagname-in-ectags-format.d/run.sh
new file mode 100644
index 0000000000..52da56f9db
--- /dev/null
+++ b/Tmain/broken-tagname-in-ectags-format.d/run.sh
@@ -0,0 +1,18 @@
+#!/bin/sh
+
+# Copyright: 2015 Masatake YAMATO
+# License: GPL-2
+
+CTAGS=$1
+BUILD_SUBDIR=$2
+stderr_tmp=${BUILD_SUBDIR}/stderr-actual.txt.tmp
+
+${CTAGS} --options=NONE -o - --language-force=CTagsSelfTest --verbose --output-format=e-ctags input.cst \
+	 2> ${stderr_tmp}
+
+# externalSortTags invokes sort command, and it is logged to stderr.
+# Delete the line for the comparison.
+sed -e '/^system ("sort -u")$/d' < ${stderr_tmp} 1>&2
+rm ${stderr_tmp}
+
+exit $?
diff --git a/Tmain/broken-tagname-in-ectags-format.d/stderr-expected.txt b/Tmain/broken-tagname-in-ectags-format.d/stderr-expected.txt
new file mode 100644
index 0000000000..77e9699cae
--- /dev/null
+++ b/Tmain/broken-tagname-in-ectags-format.d/stderr-expected.txt
@@ -0,0 +1,6 @@
+ctags: Notice: No options will be read from files or environment
+  Option: --output-format=e-ctags
+Reading command line arguments
+CTagsSelfTest requires a memory stream for input
+OPENING input.cst as CTagsSelfTest language file [new,required]
+Initialize parser: CTagsSelfTest
diff --git a/Tmain/broken-tagname-in-ectags-format.d/stdout-expected.txt b/Tmain/broken-tagname-in-ectags-format.d/stdout-expected.txt
new file mode 100644
index 0000000000..e69de29bb2
diff --git a/Tmain/broken-tagname-quiet.d/stdout-expected.txt b/Tmain/broken-tagname-quiet.d/stdout-expected.txt
index 9f05a3cb92..f200fae29d 100644
--- a/Tmain/broken-tagname-quiet.d/stdout-expected.txt
+++ b/Tmain/broken-tagname-quiet.d/stdout-expected.txt
@@ -1 +1,5 @@
+newline-in-scope	input.cst	/^b$/;"	b	broken tag:parent\nscope
 one\nof\rbroken\tname	input.cst	/^b$/;"	b	broken tag:\\Broken\tContext
+only\nnewline	input.cst	/^b$/;"	b
+only\ttab	input.cst	/^b$/;"	b
+tab-in-scope	input.cst	/^b$/;"	b	broken tag:parent\tscope
diff --git a/Tmain/broken-tagname.d/stderr-expected.txt b/Tmain/broken-tagname.d/stderr-expected.txt
index 226e6dc4fd..5ff5621f3b 100644
--- a/Tmain/broken-tagname.d/stderr-expected.txt
+++ b/Tmain/broken-tagname.d/stderr-expected.txt
@@ -10,4 +10,18 @@ Escape the character
 Unexpected character 0x09 included in a tagEntryInfo: \Broken	Context
 File: input.cst, Line: 1, Lang: CTagsSelfTest, Kind: b
 Escape the character
+Unexpected character 0x0a included in a tagEntryInfo: only
+newline
+File: input.cst, Line: 1, Lang: CTagsSelfTest, Kind: b
+Escape the character
+Unexpected character 0x09 included in a tagEntryInfo: only	tab
+File: input.cst, Line: 1, Lang: CTagsSelfTest, Kind: b
+Escape the character
+Unexpected character 0x0a included in a tagEntryInfo: parent
+scope
+File: input.cst, Line: 1, Lang: CTagsSelfTest, Kind: b
+Escape the character
+Unexpected character 0x09 included in a tagEntryInfo: parent	scope
+File: input.cst, Line: 1, Lang: CTagsSelfTest, Kind: b
+Escape the character
 sorting tag file
diff --git a/Tmain/broken-tagname.d/stdout-expected.txt b/Tmain/broken-tagname.d/stdout-expected.txt
index 9f05a3cb92..f200fae29d 100644
--- a/Tmain/broken-tagname.d/stdout-expected.txt
+++ b/Tmain/broken-tagname.d/stdout-expected.txt
@@ -1 +1,5 @@
+newline-in-scope	input.cst	/^b$/;"	b	broken tag:parent\nscope
 one\nof\rbroken\tname	input.cst	/^b$/;"	b	broken tag:\\Broken\tContext
+only\nnewline	input.cst	/^b$/;"	b
+only\ttab	input.cst	/^b$/;"	b
+tab-in-scope	input.cst	/^b$/;"	b	broken tag:parent\tscope
diff --git a/main/field.c b/main/field.c
index c96f276b1d..6955e58038 100644
--- a/main/field.c
+++ b/main/field.c
@@ -66,10 +66,10 @@ static const char *renderFieldXpath (const tagEntryInfo *const tag, const char *
 static const char *renderFieldScopeKindName(const tagEntryInfo *const tag, const char *value, vString* b);
 static const char *renderFieldEnd (const tagEntryInfo *const tag, const char *value, vString* b);
 
-static bool hasTabCharInName (const tagEntryInfo *const tag, const char *value);
-static bool hasTabCharInInput (const tagEntryInfo *const tag, const char*value);
-static bool hasTabCharInFieldScope (const tagEntryInfo *const tag, const char *value);
-static bool hasTabCharInSignature (const tagEntryInfo *const tag, const char *value);
+static bool hasTabOrNewlineCharInName (const tagEntryInfo *const tag, const char *value);
+static bool hasTabOrNewlineCharInInput (const tagEntryInfo *const tag, const char*value);
+static bool hasTabOrNewlineCharInFieldScope (const tagEntryInfo *const tag, const char *value);
+static bool hasTabOrNewlineCharInSignature (const tagEntryInfo *const tag, const char *value);
 
 static bool     isLanguageFieldAvailable  (const tagEntryInfo *const tag);
 static bool     isTyperefFieldAvailable   (const tagEntryInfo *const tag);
@@ -93,7 +93,7 @@ static bool     isEndFieldAvailable       (const tagEntryInfo *const tag);
 		.enabled       = V,		\
 		.render        = RE,		\
 		.renderNoEscaping= RN,		\
-		.hasTabChar = HSC, \
+		.hasTabOrNewlineChar = HSC, \
 		.isValueAvailable = A,		\
 		.dataType = DT, \
 	}
@@ -107,13 +107,13 @@ static fieldDefinition fieldDefinitionsFixed [] = {
 			  NULL,
 			  FIELDTYPE_STRING,
 			  renderFieldName, renderFieldNameNoEscape,
-			  hasTabCharInName),
+			  hasTabOrNewlineCharInName),
 	DEFINE_FIELD_FULL ('F', "input",    true,
 			   "input file",
 			   NULL,
 			   FIELDTYPE_STRING,
 			   renderFieldInput, renderFieldInputNoEscape,
-			   hasTabCharInInput),
+			   hasTabOrNewlineCharInInput),
 	DEFINE_FIELD ('P', "pattern",  true,
 			   "pattern",
 			   FIELDTYPE_STRING|FIELDTYPE_BOOL,
@@ -169,13 +169,13 @@ static fieldDefinition fieldDefinitionsExuberant [] = {
 			   isSignatureFieldAvailable,
 			   FIELDTYPE_STRING,
 			   renderFieldSignature, renderFieldSignatureNoEscape,
-			   hasTabCharInSignature),
+			   hasTabOrNewlineCharInSignature),
 	DEFINE_FIELD_FULL ('s', NULL,             true,
 			   "Scope of tag definition (`p' can be used for printing its kind)",
 			   NULL,
 			   FIELDTYPE_STRING,
 			   renderFieldScope, renderFieldScopeNoEscape,
-			   hasTabCharInFieldScope),
+			   hasTabOrNewlineCharInFieldScope),
 	DEFINE_FIELD_FULL ('t', "typeref",        true,
 			   "Type and name of a variable or typedef",
 			   isTyperefFieldAvailable,
@@ -205,7 +205,7 @@ static fieldDefinition fieldDefinitionsUniversal [] = {
 			   /* Following renderer is for handling --_xformat=%{scope};
 			      and is not for tags output. */
 			   renderFieldScope, renderFieldScopeNoEscape,
-			   hasTabCharInFieldScope),
+			   hasTabOrNewlineCharInFieldScope),
 	DEFINE_FIELD_FULL ('E', "extras",   false,
 			   "Extra tag type information",
 			   isExtrasFieldAvailable,
@@ -432,9 +432,9 @@ static const char *renderFieldNameNoEscape (const tagEntryInfo *const tag, const
 	return renderAsIs (b, tag->name);
 }
 
-static bool hasTabCharInName (const tagEntryInfo *const tag, const char *value CTAGS_ATTR_UNUSED)
+static bool hasTabOrNewlineCharInName (const tagEntryInfo *const tag, const char *value CTAGS_ATTR_UNUSED)
 {
-	return strchr (tag->name, '\t')? true: false;
+	return strpbrk (tag->name, "\t\n")? true: false;
 }
 
 static const char *renderFieldInput (const tagEntryInfo *const tag, const char *value CTAGS_ATTR_UNUSED, vString* b)
@@ -456,14 +456,14 @@ static const char *renderFieldInputNoEscape (const tagEntryInfo *const tag, cons
 	return renderAsIs (b, f);
 }
 
-static bool hasTabCharInInput (const tagEntryInfo *const tag, const char *value CTAGS_ATTR_UNUSED)
+static bool hasTabOrNewlineCharInInput (const tagEntryInfo *const tag, const char *value CTAGS_ATTR_UNUSED)
 {
 	const char *f = tag->inputFileName;
 
 	if (Option.lineDirectives && tag->sourceFileName)
 		f = tag->sourceFileName;
 
-	return strchr (f, '\t')? true: false;
+	return strpbrk (f, "\t\n")? true: false;
 }
 
 static const char *renderFieldSignature (const tagEntryInfo *const tag, const char *value CTAGS_ATTR_UNUSED, vString* b)
@@ -477,9 +477,9 @@ static const char *renderFieldSignatureNoEscape (const tagEntryInfo *const tag,
 	return renderAsIs (b, WITH_DEFUALT_VALUE (tag->extensionFields.signature));
 }
 
-static bool hasTabCharInSignature (const tagEntryInfo *const tag, const char *value CTAGS_ATTR_UNUSED)
+static bool hasTabOrNewlineCharInSignature (const tagEntryInfo *const tag, const char *value CTAGS_ATTR_UNUSED)
 {
-	return (tag->extensionFields.signature && strchr(tag->extensionFields.signature, '\t'))
+	return (tag->extensionFields.signature && strpbrk(tag->extensionFields.signature, "\t\n"))
 		? true
 		: false;
 }
@@ -500,12 +500,12 @@ static const char *renderFieldScopeNoEscape (const tagEntryInfo *const tag, cons
 	return scope? renderAsIs (b, scope): NULL;
 }
 
-static bool hasTabCharInFieldScope (const tagEntryInfo *const tag, const char *value CTAGS_ATTR_UNUSED)
+static bool hasTabOrNewlineCharInFieldScope (const tagEntryInfo *const tag, const char *value CTAGS_ATTR_UNUSED)
 {
 	const char* scope;
 
 	getTagScopeInformation ((tagEntryInfo *const)tag, NULL, &scope);
-	return (scope && strchr (scope, '\t'));
+	return (scope && strpbrk (scope, "\t\n"));
 }
 
 
@@ -569,26 +569,26 @@ extern const char* renderFieldNoEscaping (fieldType type, const tagEntryInfo *ta
 	return renderFieldCommon (type, tag, index, true);
 }
 
-static bool defaultHasTabChar (const tagEntryInfo *const tag CTAGS_ATTR_UNUSED, const char* value)
+static bool defaultHasTabOrNewlineChar (const tagEntryInfo *const tag CTAGS_ATTR_UNUSED, const char* value)
 {
-	return strchr (value, '\t')? true: false;
+	return strpbrk (value, "\t\n")? true: false;
 }
 
-extern bool  doesFieldHaveTabChar (fieldType type, const tagEntryInfo *tag, int index)
+extern bool  doesFieldHaveTabOrNewlineChar (fieldType type, const tagEntryInfo *tag, int index)
 {
 	fieldObject *fobj = fieldObjects + type;
 	const char *value;
-	bool (* hasTabChar) (const tagEntryInfo *const, const char*) = fobj->def->hasTabChar;
+	bool (* hasTabOrNewlineChar) (const tagEntryInfo *const, const char*) = fobj->def->hasTabOrNewlineChar;
 
 	Assert (tag);
 	Assert (index == NO_PARSER_FIELD || ((unsigned int)index) < tag->usedParserFields);
 
-	if (hasTabChar == NULL)
+	if (hasTabOrNewlineChar == NULL)
 	{
 		if (index == NO_PARSER_FIELD)
 			return false;
 		else
-			hasTabChar = defaultHasTabChar;
+			hasTabOrNewlineChar = defaultHasTabOrNewlineChar;
 	}
 
 	if (index >= 0)
@@ -600,7 +600,7 @@ extern bool  doesFieldHaveTabChar (fieldType type, const tagEntryInfo *tag, int
 	else
 		value = NULL;
 
-	return (* hasTabChar) (tag, value);
+	return (* hasTabOrNewlineChar) (tag, value);
 }
 
 /*  Writes "line", stripping leading and duplicate white space.
@@ -1046,7 +1046,7 @@ extern int defineField (fieldDefinition *def, langType language)
 	{
 		def->render = defaultRenderer;
 		def->renderNoEscaping = NULL;
-		def->hasTabChar = NULL;
+		def->hasTabOrNewlineChar = NULL;
 	}
 
 	if (! def->dataType)
diff --git a/main/field.h b/main/field.h
index d52da4ce04..a480f3685a 100644
--- a/main/field.h
+++ b/main/field.h
@@ -86,7 +86,7 @@ struct sFieldDefinition {
 
 	fieldRenderer render;
 	fieldRenderer renderNoEscaping;
-	bool (*hasTabChar) (const tagEntryInfo *const, const char*);
+	bool (*hasTabOrNewlineChar) (const tagEntryInfo *const, const char*);
 
 	bool (* isValueAvailable) (const tagEntryInfo *const);
 
diff --git a/main/field_p.h b/main/field_p.h
index 7d2b8c9fcd..8fa4ca85e3 100644
--- a/main/field_p.h
+++ b/main/field_p.h
@@ -58,7 +58,7 @@ extern bool doesFieldHaveValue (fieldType type, const tagEntryInfo *tag);
 
 extern const char* renderField (fieldType type, const tagEntryInfo *tag, int index);
 extern const char* renderFieldNoEscaping (fieldType type, const tagEntryInfo *tag, int index);
-extern bool  doesFieldHaveTabChar (fieldType type, const tagEntryInfo *tag, int index);
+extern bool  doesFieldHaveTabOrNewlineChar (fieldType type, const tagEntryInfo *tag, int index);
 
 extern void initFieldObjects (void);
 extern int countFields (void);
diff --git a/main/parse.c b/main/parse.c
index 3244cb23ad..abcf855ef6 100644
--- a/main/parse.c
+++ b/main/parse.c
@@ -4568,6 +4568,18 @@ static void createCTSTTags (void)
 						e.extensionFields.scopeKindIndex = K_BROKEN;
 						e.extensionFields.scopeName = "\\Broken\tContext";
 						makeTagEntry (&e);
+						initTagEntry (&e, "only\nnewline", i);
+						makeTagEntry (&e);
+						initTagEntry (&e, "only\ttab", i);
+						makeTagEntry (&e);
+						initTagEntry (&e, "newline-in-scope", i);
+						e.extensionFields.scopeKindIndex = K_BROKEN;
+						e.extensionFields.scopeName = "parent\nscope";
+						makeTagEntry (&e);
+						initTagEntry (&e, "tab-in-scope", i);
+						e.extensionFields.scopeKindIndex = K_BROKEN;
+						e.extensionFields.scopeName = "parent\tscope";
+						makeTagEntry (&e);
 						break;
 					case K_NO_LETTER:
 						initTagEntry (&e, "abnormal kindDefinition testing (no letter)", i);
diff --git a/main/writer-ctags.c b/main/writer-ctags.c
index 0221448525..115930a1f1 100644
--- a/main/writer-ctags.c
+++ b/main/writer-ctags.c
@@ -75,25 +75,25 @@ tagWriter eCtagsWriter = {
 	.defaultFileName = CTAGS_FILE,
 };
 
-static bool hasTagEntryTabChar (const tagEntryInfo * const tag)
+static bool hasTagEntryTabOrNewlineChar (const tagEntryInfo * const tag)
 {
 
-	if (doesFieldHaveTabChar (FIELD_NAME, tag, NO_PARSER_FIELD)
-		|| doesFieldHaveTabChar (FIELD_INPUT_FILE, tag, NO_PARSER_FIELD))
+	if (doesFieldHaveTabOrNewlineChar (FIELD_NAME, tag, NO_PARSER_FIELD)
+		|| doesFieldHaveTabOrNewlineChar (FIELD_INPUT_FILE, tag, NO_PARSER_FIELD))
 		return true;
 
 	if (tag->lineNumberEntry)
 	{
 		if (Option.lineDirectives)
 		{
-			if (doesFieldHaveTabChar (FIELD_LINE_NUMBER, tag, NO_PARSER_FIELD))
+			if (doesFieldHaveTabOrNewlineChar (FIELD_LINE_NUMBER, tag, NO_PARSER_FIELD))
 				return true;
 		}
 	}
-	else if (doesFieldHaveTabChar (FIELD_PATTERN, tag, NO_PARSER_FIELD))
+	else if (doesFieldHaveTabOrNewlineChar (FIELD_PATTERN, tag, NO_PARSER_FIELD))
 	{
-		/* Pattern may have a tab char. However, doesFieldHaveTabChar returns
-		 * false because NO_PARSER_FIELD may not have hasTabChar handler.
+		/* Pattern may have a tab char. However, doesFieldHaveTabOrNewlineChar returns
+		 * false because NO_PARSER_FIELD may not have hasTabOrNewlineChar handler.
 		 */
 		return true;
 	}
@@ -101,14 +101,14 @@ static bool hasTagEntryTabChar (const tagEntryInfo * const tag)
 	if (includeExtensionFlags ())
 	{
 		if (isFieldEnabled (FIELD_SCOPE) && doesFieldHaveValue (FIELD_SCOPE, tag)
-			&& (doesFieldHaveTabChar (FIELD_SCOPE_KIND_LONG, tag, NO_PARSER_FIELD)
-				|| doesFieldHaveTabChar (FIELD_SCOPE, tag, NO_PARSER_FIELD)))
+			&& (doesFieldHaveTabOrNewlineChar (FIELD_SCOPE_KIND_LONG, tag, NO_PARSER_FIELD)
+				|| doesFieldHaveTabOrNewlineChar (FIELD_SCOPE, tag, NO_PARSER_FIELD)))
 			return true;
 		if (isFieldEnabled (FIELD_TYPE_REF) && doesFieldHaveValue (FIELD_TYPE_REF, tag)
-			&& doesFieldHaveTabChar (FIELD_TYPE_REF, tag, NO_PARSER_FIELD))
+			&& doesFieldHaveTabOrNewlineChar (FIELD_TYPE_REF, tag, NO_PARSER_FIELD))
 			return true;
 		if (isFieldEnabled (FIELD_FILE_SCOPE) && doesFieldHaveValue (FIELD_FILE_SCOPE, tag)
-			&& doesFieldHaveTabChar (FIELD_FILE_SCOPE, tag, NO_PARSER_FIELD))
+			&& doesFieldHaveTabOrNewlineChar (FIELD_FILE_SCOPE, tag, NO_PARSER_FIELD))
 			return true;
 
 		int f[] = { FIELD_INHERITANCE,
@@ -123,7 +123,7 @@ static bool hasTagEntryTabChar (const tagEntryInfo * const tag)
 		for (unsigned int i = 0; f[i] >= 0; i++)
 		{
 			if (isFieldEnabled (f[i]) && doesFieldHaveValue (f[i], tag)
-				&& doesFieldHaveTabChar (f[i], tag, NO_PARSER_FIELD))
+				&& doesFieldHaveTabOrNewlineChar (f[i], tag, NO_PARSER_FIELD))
 				return true;
 		}
 	}
@@ -134,7 +134,7 @@ static bool hasTagEntryTabChar (const tagEntryInfo * const tag)
 		fieldType ftype = f->ftype;
 		if (isFieldEnabled (ftype))
 		{
-			if (doesFieldHaveTabChar (ftype, tag, i))
+			if (doesFieldHaveTabOrNewlineChar (ftype, tag, i))
 				return true;
 		}
 	}
@@ -301,7 +301,7 @@ static int writeCtagsEntry (tagWriter *writer,
 	if (writer->private)
 	{
 		struct rejection *rej = writer->private;
-		if (hasTagEntryTabChar (tag))
+		if (hasTagEntryTabOrNewlineChar (tag))
 		{
 			rej->rejectionInThisInput = true;
 			return 0;
